package net.pricefx.logic.core.model;

import java.util.Objects;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import net.pricefx.logic.core.util.StringUtils;


@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2017-11-10T15:30:45.019+01:00")
public class FormulaTraceMessage   {

  private static int MAX_RESULT_STR_CHARS = 300;

  private String functionName = null;
  private String parameters = null;
  private Object result = null;

  private String resultStr = null;

  
  /**
   **/
  public FormulaTraceMessage functionName(String functionName) {
    this.functionName = functionName;
    return this;
  }
  
  @JsonProperty("functionName")
  public String getFunctionName() {
    return functionName;
  }
  public void setFunctionName(String functionName) {
    this.functionName = functionName;
  }

  
  /**
   **/
  public FormulaTraceMessage parameters(String parameters) {
    this.parameters = parameters;
    return this;
  }
  
  @JsonProperty("parameters")
  public String getParameters() {
    return parameters;
  }
  public void setParameters(String parameters) {
    this.parameters = parameters;
  }

  
  /**
   **/
  public FormulaTraceMessage result(Object result) {
    this.result = result;
    return this;
  }
  
  @JsonProperty("result")
  public Object getResult() {
    return result;
  }
  public void setResult(Object result) {
    this.result = result;
    this.resultStr = result == null ? null : StringUtils.replaceLastThreeCharactersWithinLimitWithDots(result.toString(), MAX_RESULT_STR_CHARS);
  }

  @JsonIgnore
  public String getResultStr() {
    return resultStr;
  }

  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FormulaTraceMessage formulaTraceMessage = (FormulaTraceMessage) o;
    return Objects.equals(this.functionName, formulaTraceMessage.functionName) &&
        Objects.equals(this.parameters, formulaTraceMessage.parameters) &&
        Objects.equals(this.result, formulaTraceMessage.result);
  }

  @Override
  public int hashCode() {
    return Objects.hash(functionName, parameters, result);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FormulaTraceMessage {\n");
    
    sb.append("    functionName: ").append(toIndentedString(functionName)).append("\n");
    sb.append("    parameters: ").append(toIndentedString(parameters)).append("\n");
    sb.append("    result: ").append(toIndentedString(result)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

